package cache

import (
	"sync"
)

/*********************************************************代理商**/
//// AgentMap 代理商
//var AgentMap sync.Map
/*---------------------------------------------------------------*/

/*********************************************************运营商**/
var operatorMap sync.Map //运营商id作为KEY
type OperatorStruct struct {
	ShortName string
	AreaID    []int //区域ID
	// 可再添加运营商属性
}

/*---------------------------------------------------------------*/

/******************************************************区域(校区)服务信息**/
var areaServiceMap sync.Map     //area_service_id 作为KEY  AreaStruct 作为VALUE
type AreaServiceStruct struct { //
	AreaID     int
	ServiceID  uint8  //服务项目 1公话 2定位 3饮水 4POS .........
	OperatorID int32  //运营商ID
	Name       string //服务名字(例宿舍135栋饮水)name
	Status     uint8  //状态 1正式2测试3暂停
}

/*---------------------------------------------------------------*/

/******************************************************后台管理用户**/
var adminMap sync.Map //后台管理用户  LoginAccount(string) 作为KEY
type AdminStruct struct {
	Password       [16]byte
	tokenCreatTime uint32
	Name           string
	//Phone string
	//OperatorID []int
	SystemAuth      int     //系统角色权限
	AreaServiceAuth [][]int //area_service_id,admin_role_id
}

/*---------------------------------------------------------------*/

// roleAuthMap /****************************角色权限(包含区域和系统角色)*/
var adminRoleAuthMap sync.Map //admin_role_id 作为KEY
type RoleAuthStruct struct {
	Name string
	// 考虑接口、菜单、按钮权限
}

/*---------------------------------------------------------------*/

/******************************************************区域(校区)**/
var areaMap sync.Map     //area_id 作为KEY  AreaStruct 作为VALUE
type AreaStruct struct { // AreaStruct 区域信息缓存，通过区域ID查出,后续再加支付信息
	// OperatorID int32 //运营商ID
	Name            string
	Status          bool //校区状态
	ServicePhone    bool
	ServiceWater    bool
	ServiceLocation bool
	ServicePos      bool
}

/*---------------------------------------------------------------*/

/***************************************************微信用户(家长)**/
var wechatCustomerMap sync.Map //微信的WechatUnionID(string)作为KEY
type WechatCustomerStruct struct {
	tokenCreatTime uint32
	CardUserID     []int
}

/****************************************************************/

/***************************************************卡用户(学生、教师、职工)**/
var cardUserMap sync.Map //卡用户 CardUserID卡用户ID(int) 作为KEY   纯卡用户可以不绑定微信
type CardUserType struct {
	// WechatUnionID string
	// AreaID int
	AreaServiceID int
	Name          string
	Sex           uint8
	// Birthday
	Grade     uint8
	Class     uint8
	StudentNo string
	Card      CardStruct
}
type CardStruct struct {
	Sim      []string //电话卡 这里考虑下是否允许多张
	Water    []uint32 //水卡
	Location []uint32 //定位卡
	Pos      []uint32 //pos消费卡
}

/*---------------------------------------------------------------*/

/*******************************************************电话设备**/
var phone20DeviceMap sync.Map //device_id 作为KEY  Phone20DeviceStruct 作为VALUE
type Phone20DeviceStruct struct {
	AreaServiceID int
	AllowCallTime uint8 //允许通话时长,255表示不限制时长
	Status        bool
}

/*---------------------------------------------------------------*/

/********************************************************Sim卡信息**/
var simInfoMap sync.Map //card_id 作为KEY
type SimInfoStruct struct {
	CardUserID          int  //卡用户ID
	Status              int8 //0没得这个数据   1 正常使用   其他各种异常
	MonthTalkMinutes    uint16
	MonthPackageMinutes uint16
	FamilyNum           []FamilyOnePerson
}
type FamilyOnePerson struct {
	Phone    string
	Nickname string
}

/*---------------------------------------------------------------*/

///********************************************************Sim卡信息(允许一卡多校区使用)**/
//var simInfoMap sync.Map //card_id 作为KEY
//type SimInfoStruct struct {
//	Status              int8 //0没得这个数据   1 正常使用   其他各种异常
//	MonthTalkMinutes    uint16
//	MonthPackageMinutes uint16
//	AreaFamilyNum       []sync.Map //area_id为KEY , []familyOnePerson 为 VALUE
//}
//type FamilyOnePerson struct {
//	Phone    string
//	Nickname string
//}
///*---------------------------------------------------------------*/

///*******************************************************定位设备**/
//var phone20DeviceMap sync.Map //device_id 作为KEY  DeviceStruct 作为VALUE
//type Phone20DeviceStruct struct {
//	AreaID        int32
//	AllowCallTime uint8 //允许通话时长,255表示不限制时长
//	Status        bool
//}
///*---------------------------------------------------------------*/
//
//
///*******************************************************饮水设备**/
//var phone20DeviceMap sync.Map //device_id 作为KEY  DeviceStruct 作为VALUE
//type Phone20DeviceStruct struct {
//	AreaID        int32
//	AllowCallTime uint8 //允许通话时长,255表示不限制时长
//	Status        bool
//}
///*---------------------------------------------------------------*/

func Init() {
	initOperatorMap()
	initWechatCustomerMap()
	initCardUserMap()
	initAreaMap()
	initPhone20DeviceMap()
	initSimFamilyNumMap()
}
